//
// URLHelp.c
//
// written by Bob Lord 3/96
//

#include <windows.h>
#include <ddeml.h>
#include <limits.h>
#include <stdio.h>
#include "FindWin.h"

const char cszDDECommandKey[]     = "SOFTWARE\\classes\\http\\shell\\open\\command";
const char cszDDEExecKey[]		  = "SOFTWARE\\classes\\http\\shell\\open\\ddeexec";
const char cszDDEApplicationKey[] = "SOFTWARE\\classes\\http\\shell\\open\\ddeexec\\Application";
const char cszDDETopicKey[]       = "SOFTWARE\\classes\\http\\shell\\open\\ddeexec\\Topic";


HDDEDATA CALLBACK DdeCallback(UINT uType, UINT uFmt, HCONV hconv, HSZ hsz1, HSZ hsz2,
							  HDDEDATA hdata, DWORD dwData1, DWORD dwData2) 
{ 
    switch (uType)
	{ 
        case XTYP_ADVDATA: 
            return (HDDEDATA)DDE_FACK; 

        default: 
            return (HDDEDATA)NULL; 
    } 
} 


LONG GetRegSzValue(HKEY hKey, LPCTSTR lpSubKey, LPCTSTR lpName, LPSTR *lplpszValue)
{
	LONG result;
	HKEY hkRegKey;
	DWORD dwType;
	DWORD dwSize;
	
	result = RegOpenKeyEx(hKey, lpSubKey, 0L, KEY_READ, &hkRegKey);
	if (result == ERROR_SUCCESS)
    {
        result = RegQueryValueEx(hkRegKey, lpName, NULL, &dwType, NULL, &dwSize);
	    if (result == ERROR_SUCCESS)
        {
            *lplpszValue = NULL;
	        if (dwType == REG_SZ)
		        if (dwSize != 0 && dwSize <= UINT_MAX)
		        {	
			        *lplpszValue = malloc(dwSize);
			        if (*lplpszValue != NULL)
				        result = RegQueryValueEx(hkRegKey, lpName, NULL, &dwType, *lplpszValue, &dwSize);
		        }
        }
        RegCloseKey(hkRegKey);
	    if (*lplpszValue == NULL)
		    result = ERROR_INVALID_FUNCTION;
    }
	return result;
}


__declspec(dllexport) void DisplayURL(LPCSTR lpszURL)
{
	LPSTR lpszCommand=NULL;
	LPSTR lpszExec=NULL;
	LPSTR lpszURLExec=NULL;
	LPSTR lpszApplication=NULL;
	LPSTR lpszTopic=NULL;
	DWORD idInst=0;
	HSZ hszService, hszTopic, hszItem;
	HCONV hConv;
	HDDEDATA hData;
	HCURSOR hcurStarting, hcurOld;
	
        hcurStarting = LoadCursor(NULL, IDC_APPSTARTING);
	hcurOld = SetCursor(hcurStarting);

	GetRegSzValue(HKEY_LOCAL_MACHINE, cszDDEExecKey, NULL, &lpszExec);
	if (lpszExec)
	{
		lpszURLExec = malloc(lstrlen(lpszExec) - 2 + lstrlen(lpszURL) + 1);
		if (lpszURLExec)
		{
			char *pFrom = lpszExec;
			char *pTo = lpszURLExec;

			while (*pFrom != '%' && *(pFrom + 1) != '1')
				*pTo++ = *pFrom++;
			lstrcpy(pTo, lpszURL);
			pFrom += 2;
			lstrcat(pTo, pFrom);
		}
	}
	free(lpszExec);

	GetRegSzValue(HKEY_LOCAL_MACHINE, cszDDECommandKey, NULL, &lpszCommand);
	GetRegSzValue(HKEY_LOCAL_MACHINE, cszDDEApplicationKey, NULL, &lpszApplication);
	GetRegSzValue(HKEY_LOCAL_MACHINE, cszDDETopicKey, NULL, &lpszTopic);

	if (lpszCommand && lpszURLExec && lpszApplication && lpszTopic)
	{
		if (DdeInitialize(&idInst, DdeCallback,
		  APPCLASS_STANDARD | APPCMD_CLIENTONLY, 0L) == DMLERR_NO_ERROR)
		{
			hszService = DdeCreateStringHandle(idInst, lpszApplication, CP_WINANSI);
			hszTopic = DdeCreateStringHandle(idInst, lpszTopic, CP_WINANSI);
			if (hszService && hszTopic)
			{
				hConv = DdeConnect(idInst, hszService, hszTopic, NULL);
				if (!hConv)
					WinExec(lpszCommand, SW_SHOWNORMAL);
				hConv = DdeConnect(idInst, hszService, hszTopic, NULL);
				if (hConv)
				{
					DdeClientTransaction((LPSTR)lpszURLExec, lstrlen(lpszURLExec) + 1,
					  hConv, 0, 0, XTYP_EXECUTE, TIMEOUT_ASYNC, NULL);
					DdeDisconnect(hConv);
				}
			}

			if (lstrcmp(lpszApplication, "IExplore") != 0)
			{
				if (hszTopic)
					DdeFreeStringHandle(idInst, hszTopic);
				hszTopic = DdeCreateStringHandle(idInst, "WWW_GetWindowInfo", CP_WINANSI);
				hszItem = DdeCreateStringHandle(idInst, "-1", CP_WINANSI);
				if (hszService && hszTopic && hszItem)
				{
					hConv = DdeConnect(idInst, hszService, hszTopic, NULL);
					if (hConv)
					{
						char *pStart, *pEnd;
						HWND hwnd;

						hData = DdeClientTransaction(NULL, 0, hConv, hszItem, CF_TEXT,
						  XTYP_REQUEST, 1000, NULL);
						if (hData)
						{
							pStart = DdeAccessData(hData, NULL);
						
							++pStart;
							while (*pStart != '\"')
								++pStart;
							pStart += 3;
							pEnd = pStart;
							while (*pEnd != '\"')
								++pEnd;
							*pEnd = 0;

							hwnd = FindWindowByTitle(pStart);
							if (hwnd)
							{
								if (IsIconic(hwnd))
									ShowWindow(hwnd, SW_RESTORE);
								SetForegroundWindow(hwnd);
							}

							DdeUnaccessData(hData);
						}

						DdeDisconnect(hConv);
					}
				}

	    		if (hszItem)
					DdeFreeStringHandle(idInst, hszItem);
			}
			if (hszTopic)
				DdeFreeStringHandle(idInst, hszTopic);
			if (hszService)
				DdeFreeStringHandle(idInst, hszService);
			DdeUninitialize(idInst);
		}
	}
	free(lpszURLExec);
	free(lpszTopic);
	free(lpszApplication);
	free(lpszCommand);

	SetCursor(hcurOld);
}
