// WINMOCK.H -- copyright (C), 1995 -- J. Hlavaty

#define APIENTRY FAR PASCAL
int APIENTRY WEP( int bExit ) ;
void BuildFunctionTable( void ) ;
LPSTR FindFunctionName( int index ) ;
BOOL  LogString( LPCSTR lpsz ) ;

#define MAKEWORD(low, high) ((WORD)(((char)(low)) | (((WORD)((char)(high))) << 8)))
#define MAXSOCKETS   5
#define MAXTASKS     5
#define MAXUDPDG   512

#define ADDRBUFFERSIZE 20
#define PROTOBUFFERSIZE 20

#define ERRORSTRINGSIZE 64
#define ERRORLISTSIZE   54

typedef struct tagSocketData
{
   SOCKET    mys ;                     // socket id
   HTASK     mytask ;                  // task owning this socket
   BOOL      isconnected ;             // whether connect()/bind() has been
                                       //   called on this socket
   BOOL      isstillreceiving ;        // whether socket is receiving and not
                                       //   received everything
   BOOL      socketblocking ;          // blocking = TRUE
   WORD      socketfamily ;
   WORD      socketprotocol ;          // UDP/TCP
   WORD      sockettype ;              // SOCK_STREAM/SOCK_DGRAM
   HANDLE    hRecv ;                   // global handle to received block
   WORD      wRecvSize ;               // size of received block
   WORD      wRecvOffset ;             // current offset into received block
   HANDLE    hSend ;                   // global handle to sent block
   struct tagSocketData* psnext ;

}  MYSOCKET ;

typedef MYSOCKET *PMYSOCKET ;

#define SIZEOFNAMESPACE 25

typedef struct tagTaskData
{
   HTASK      mytask ;                 // task id
   LPHOSTENT  myhostent ;              // HOSTENT structure for this task
   LPPROTOENT myprotoent ;             // PROTOENT structure for this task
   LPSERVENT  myservent ;              // SERVENT structure for this task
   BOOL       isblocking ;             // whether task is currently blocked
                                       //   because a blocking call is in progress
   int        mylasterror ;            // what WSAGETLASTERROR returns
   int        WSAStartupCount ;        // # of times WSAStartup() called by
                                       //   (or for) task
   char szNameSpace[SIZEOFNAMESPACE] ; // temporary space for strings to
                                       //   to be passed to caller
   struct tagTaskData* ptnext ;

}  MYTASK ;

typedef MYTASK *PMYTASK ;

LPSTR wmfmemcpy( LPSTR pd, LPSTR ps, unsigned int count ) ;
LPSTR wmfstrcpy( LPSTR d, LPSTR s )  ;
int wmfstrcmp( LPSTR s1, LPSTR s2 ) ;
int   wmfstrlen( LPSTR ) ;

PMYTASK wmAddTask( HTASK ht ) ;
void wmClearSocketsForThisTask( HTASK ht ) ;
void wmClearSocketStruct( PMYSOCKET pthissocket ) ;
WORD  wmConvertErrorString( LPSTR lpszErrorString ) ;
PMYSOCKET wmGetFreeSocket( void ) ;
PMYSOCKET wmGetSocketInfo( SOCKET s ) ;
PMYTASK wmGetTaskInfo( HTASK ht ) ;
WORD wmInitializeSocketList( void ) ;
WORD wmInitializeTaskList( void ) ;
HANDLE wmLoadFile( LPSTR lpszFileName ) ;
void wmRemoveTaskStruct( PMYTASK pthistask ) ;

#define NUMBEROFWINSOCKFUNCTIONS        48

#define FUNC_GETHOSTBYADDR               0
#define FUNC_RECV                        1
#define FUNC_GETHOSTBYNAME               2
#define FUNC_GETSERVBYNAME               3
#define FUNC_LISTEN                      4
#define FUNC_WSAGETLASTERROR             5
#define FUNC_GETPROTOBYNAME              6
#define FUNC_INET_ADDR                   7
#define FUNC_WSASETLASTERROR             8
#define FUNC_WSACANCELBLOCKINGCALL       9
#define FUNC_WSAUNHOOKBLOCKINGHOOK      10
#define FUNC_WSACANCELASYNCREQUEST      11
#define FUNC_WSASETBLOCKINGHOOK         12
#define FUNC_BIND                       13
#define FUNC_GETSOCKNAME                14
#define FUNC_GETLASTERROR               15
#define FUNC_SEND                       16
#define FUNC_SHUTDOWN                   17
#define FUNC_WSASTARTUP                 18
#define FUNC_CONNECT                    19
#define FUNC_GETSOCKOPT                 20
#define FUNC___WSAFDISSET               21
#define FUNC_HTONL                      22
#define FUNC_NTOHL                      23
#define FUNC_WSAISBLOCKING              24
#define FUNC_HTONS                      25
#define FUNC_WSAASYNCGETSERVBYPORT      26
#define FUNC_NTOHS                      27
#define FUNC_GETPEERNAME                28
#define FUNC_SETSOCKOPT                 29
#define FUNC_ACCEPT                     30
#define FUNC_WSAASYNCGETPROTOBYNUMBER   31
#define FUNC_RECVFROM                   32
#define FUNC_WSAASYNCSELECT             33
#define FUNC_GETSERVBYPORT              34
#define FUNC_IOCTLSOCKET                35
#define FUNC_INET_NTOA                  36
#define FUNC_GETPROTOBYNUMBER           37
#define FUNC_WSACLEANUP                 38
#define FUNC_SOCKET                     39
#define FUNC_WSAASYNCGETHOSTBYADDR      40
#define FUNC_GETHOSTNAME                41
#define FUNC_WSAASYNCGETHOSTBYNAME      42
#define FUNC_WSAASYNCGETSERVBYNAME      43
#define FUNC_SELECT                     44
#define FUNC_WSAASYNCGETPROTOBYNAME     45
#define FUNC_CLOSESOCKET                46
#define FUNC_SENDTO                     47

#ifndef NO_EXTERNS
  extern FARPROC afnWinSock[ ] ;
  extern HMODULE hRealWinSock ;
  extern bWaitingForReceive ;
  extern char szErrorString[ ] ;
  extern char    szBuffer[ ] ;

  extern MYSOCKET asockets[ ] ;
  extern PMYSOCKET pasocketshead ;
  extern int nsockets ;

  extern MYTASK atasks[ ] ;
  extern PMYTASK pataskshead ;
  extern int ntasks ;
  extern struct ERRORENTRY ErrorList[] ;
#endif

enum errors
{
  zero=0,
  socketerror=-1,
  wsabaseerr=         WSABASEERR,
  wsaeintr=           WSAEINTR,
  wsaebadf=           WSAEBADF,
  wsaeacces=          WSAEACCES,
  wsaefault=          WSAEFAULT,
  wsaeinval=          WSAEINVAL,
  wsaemfile=          WSAEMFILE,
  wsaewouldblock=     WSAEWOULDBLOCK,
  wsaeinprogress=     WSAEINPROGRESS,
  wsaealready=        WSAEALREADY,
  wsaenotsock=        WSAENOTSOCK,
  wsaedestaddrreq=    WSAEDESTADDRREQ,
  wsaemsgsize=        WSAEMSGSIZE,
  wsaeprototype=      WSAEPROTOTYPE,
  wsaenoprotoopt=     WSAENOPROTOOPT,
  wsaeprotonosupport= WSAEPROTONOSUPPORT,
  wsaesocktnosupport= WSAESOCKTNOSUPPORT,
  wsaeopnotsupp=      WSAEOPNOTSUPP,
  wsaepfnosupport=    WSAEPFNOSUPPORT,
  wsaeafnosupport=    WSAEAFNOSUPPORT,
  wsaeaddrinuse=      WSAEADDRINUSE,
  wsaeaddrnotavail=   WSAEADDRNOTAVAIL,
  wsaenetdown=        WSAENETDOWN,
  wsaenetunreach=     WSAENETUNREACH,
  wsaenetreset=       WSAENETRESET,
  wsaeconnaborted=    WSAECONNABORTED,
  wsaeconnreset=      WSAECONNRESET,
  wsaenobufs=         WSAENOBUFS,
  wsaeisconn=         WSAEISCONN,
  wsaenotconn=        WSAENOTCONN,
  wsaeshutdown=       WSAESHUTDOWN,
  wsaetoomanyrefs=    WSAETOOMANYREFS,
  wsaetimedout=       WSAETIMEDOUT,
  wsaeconnrefused=    WSAECONNREFUSED,
  wsaeloop=           WSAELOOP,
  wsaenametoolong=    WSAENAMETOOLONG,
  wsaehostdown=       WSAEHOSTDOWN,
  wsaehostunreach=    WSAEHOSTUNREACH,
  wsaenotempty=       WSAENOTEMPTY,
  wsaeproclim=        WSAEPROCLIM,
  wsaeusers=          WSAEUSERS,
  wsaedquot=          WSAEDQUOT,
  wsaestale=          WSAESTALE,
  wsaeremote=         WSAEREMOTE,
  wsasysnotready=     WSASYSNOTREADY,
  wsavernotsupported= WSAVERNOTSUPPORTED,
  wsanotinitialised=  WSANOTINITIALISED,
  wsahost_not_found=  WSAHOST_NOT_FOUND,
  wsatry_again=       WSATRY_AGAIN,
  wsano_recovery=     WSANO_RECOVERY,
  wsano_data=         WSANO_DATA,
  wsano_address=      WSANO_ADDRESS,
} ;

struct ERRORENTRY
{
  char         *pszError ;
  enum Errors   iError ;
} ;

#define LOGGING

#ifdef LOGGING
#pragma message ( "Logging" )
#define LOGS( S ) \
   wsprintf( szBuffer, S ) ; \
   LogString( szBuffer ) ;
#else
#define LOGS ( S )
#endif

#ifdef LOGGING
#define LOGSX( S, X ) \
   wsprintf( szBuffer, S, X ) ; \
   LogString( szBuffer ) ;
#else
#define LOGSX ( S, X )
#endif

#ifdef LOGGING
#define LOGSL( S, L ) \
   wsprintf( szBuffer, S, L ) ; \
   LogString( szBuffer ) ;
#else
#define LOGSL ( S, L )
#endif

#ifdef LOGGING
#define LOGSS( S, S2 ) \
   wsprintf( szBuffer, S, S2 ) ; \
   LogString( szBuffer ) ;
#else
#define LOGSL ( S, S2 )
#endif

